{

 This program produces the installability graphs for QA weekly and
 monthly reports.   The program runs only from command line arguments.

 The call is   INGRAPH filename.ext [dummy argument]

   where;

      filename.ext  is the external structured file that contains all
                    of the required data and graph header information.
                    See sample file, MO-xxx.DAT.

     [dummy argument] is any second argument (a singel character will
                    work) that if present toggles on the verbose mode.
                    In this mode a series of status messages are writen
                    to the screen as INGRAPH progresses. Otherwise, there
                    is no output to the screen by INGRAPH.


 The base assumption is that a HP Laser printer is present as the
 'lst' device.



 Source by Neil Everhart, Nov. 1988.  Released to the public domain with
 no warranty expressed or implied.

}
program INgraph;

uses CRT, PRINTER, hplj;

var   FrameWidth   : integer;
      StartX, EndY : integer;
      FrameHeight  : real;
      Title        : string[80];
      SubTitle     : string[80];
      FootNote     : string[80];
      DataLabel1   : string[32];
      DataLabel2   : string[32];
      DataLabel3   : string[32];
      NoOfXplots   : integer;
      Xplotpts     : array[0..19] of real;  { x axis plot coordinates }
      Data1, Data2,
      Data3        : array[0..19] of real;
      Xdata        : array[0..19] of string[16];
      Yinc         : integer;               { Y axis label increment value }
      PosDL1,
      PosDL2,
      PosDL3       : integer;  { location of key symbols for x labels }
      verbose      : boolean;
      InFile       : text;
      result       : integer; { local i/o result }

procedure AT(Col,Row : integer);
begin GoToXY(Col,Row) end;

procedure PutPoint1(col, row : integer); { placed at dot coordinates }
var i, j : integer;
begin
  for i := -4 to 4 do setbit(col+i,row,true);
  for i := -4 to 4 do setbit(col,row+i,true);
  for i := -4 to 4 do setbit(col+i,row+i,true);
  for i := -4 to 4 do setbit(col-i,row+i,true);
end;

procedure PutPoint2(col, row : integer); { placed at dot coordinates }
var i, j : integer;
     state : boolean;
begin
  for i := 1 to 8 do for j := 1 to 8 do
  begin
    if (i = 1) or (i = 8) then state := true else
    if ((i <> 1) and (i <> 8)) and ((j = 1) or (j = 8)) then state := true
    else state := false;
    setbit( col+i-4, row+j-4, state);
  end;

end;


procedure PutPoint3(col, row : integer); { placed at dot coordinates }
var i, j : integer;
     state : boolean;
begin
  setbit(col,row,true);
  setbit(col,row+1,true);
end;



procedure DoFrame;
var      StartY, EndX : integer;
    i, cell, dotswide : integer;
      holder1, holder : real;
    cell1, cnt, space : integer;
     portion, OffsetY : real;

begin
   if verbose then
   begin
     at(10,15);  write('Generating graph rastor image in memory.');
   end;
   cell := 5;
   FrameWidth := (cell * (NoOfXplots -1)) + 5;
   while FrameWidth < 70 do
   begin
     inc(cell);
     FrameWidth := (cell * (NoOfXplots -1)) + 5;
   end;
   FrameHeight := 4.16667;
   StartX := trunc((110 - FrameWidth)/2);
   EndX   := StartX + FrameWidth;
   StartY := trunc(((8.0 - FrameHeight)/2) * 6);
   EndY   := StartY + trunc(FrameHeight * 6);
   FrameChr(StartX, StartY, EndX, EndY);

   HchrLn(StartX-10,5,EndX+10,3,0);


   for i := 0 to NoOfXplots - 1 do  { set X axis plot coordinates and }
   begin                                                 { draw ticks }
     Xplotpts[i] := ((StartX + 2 + (i * cell))/10) + 0.05;
     DoLine(Xplotpts[i], (EndY - 1.0)/6, Xplotpts[i], EndY / 6,2,0);
   end;

   dotswide := trunc((FrameWidth/10) * 75);  { do horiz. dot lines }
   i := 0;
   repeat
     if i > 10 then inc(i,3) else inc(i);
     setbit(trunc((StartX -1.0) * 7.5) + i, trunc((StartY) * 12.5) + 56, true);
     setbit(trunc((StartX -1.0) * 7.5) + i, trunc((StartY) * 12.5) + 119, true);
     setbit(trunc((StartX -1.0) * 7.5) + i, trunc((StartY) * 12.5) + 181, true);
     setbit(trunc((StartX -1.0) * 7.5) + i, trunc((StartY) * 12.5) + 243, true);

   until i >= dotswide ;

   holder := 100.0;        { find lowest data value for y axis increment }
   for i := 1 to NoOfXplots do              { Yinc is then used to write }
   begin                                    { Y text labels & establishes }
     if Data1[i] < holder then holder := Data1[i];  { the Y increment val }
     if Data2[i] < holder then holder := Data2[i];  { used below }
     if Data3[i] < holder then holder := Data3[i];
   end;
   if holder >= 75 then Yinc :=  5 else
   if holder >= 50 then Yinc := 10 else
   if holder >= 25 then Yinc := 15 else Yinc := 20;

                                             { put X axis label key symbols }
   cnt := length(DataLabel1) + length(DataLabel2) + length(DataLabel3) + 15;
   space := 0;
   for i := 1 to  (105 - cnt) div 2 do inc(space);

   DoLine(((space+3) /10)-0.2,(40 /6) + 0.07,     { do first key symbol }
          ((space+3) /10)+0.2,(40 /6) + 0.07,1,0);
   PutPoint1(round((space+3) * 7.5),round(40 * 12.5) +5);
                                                         { do the second }
   Doline(((space+8+length(DataLabel1)) /10)-0.2,(40 /6) + 0.07,
          ((space+8+length(DataLabel1)) /10)+0.25,(40 /6) + 0.07,-1,0);
   PutPoint2(round((space+8+length(DataLabel1)) * 7.5),round(40 * 12.5) + 5);

                                                  { draw a bar for the third }
   DoLine(((space+13+length(DataLabel1) + length(DataLabel2)) /10)-0.2,
           (40 /6) + 0.07,
          ((space+13+length(DataLabel1) + length(DataLabel2)) /10)+0.2,
          (40 /6) + 0.07,3,0);

                                                        { do actual plots }


   case Yinc of                   { calc offsets a ratios }
       5 : begin
             OffSetY := 75.0;
             portion := (25/6)/25;
           end;
      10 : begin
             OffSetY := 50.0;
             portion := (25/6)/50;
           end;
      15 : begin
             OffSetY := 25.0;
             portion := (25/6)/75;
           end;
      20 : begin
             OffSetY :=  0.0;
             portion := (25/6)/100;
           end;

   end; { case }


   cell := 0;            { draw third plot line ... }
   repeat                       { check for valid first data in array }
     inc(cell);
   until (Data3[cell] < 999.99) or (cell >= NoOfXplots);
   repeat
     holder1 := (25/6) - ((Data3[cell] - OffSetY) * portion) + 1.74;
     cell1 := cell;
     repeat
       inc(cell1);
     until (Data3[cell1] < 999.99) or (cell1 >= NoOfXplots);
     holder  := (25/6) - ((Data3[cell1] - OffSetY) * portion) + 1.74;
     if Data3[cell1] < 999.99 then
      DoLine(Xplotpts[cell-1],holder1, Xplotpts[cell1 -1], holder,3,0);
     repeat
       inc(cell);
     until (Data3[cell] < 999.99) or (cell >= NoOfXplots);
   until cell >= NoOfXplots;

   for i := 0 to NoOfXplots -1 do          { do third line plot points }
   begin
     if Data3[i+1] < 999.99 then
     begin
       holder  := ((25/6) - ((Data3[i+1] - OffSetY) * portion) + 1.74) * 75;
       PutPoint3(round(Xplotpts[i] * 75),round(holder) );
     end;
   end;


   cell := 0;            { draw first plot line ... }
   repeat                       { check for valid first data in array }
     inc(cell);
   until (Data1[cell] < 999.99) or (cell >= NoOfXplots);
   repeat
     holder1 := (25/6) - ((Data1[cell] - OffSetY) * portion) + 1.74;
     cell1 := cell;
     repeat
       inc(cell1);
     until (Data1[cell1] < 999.99) or (cell1 >= NoOfXplots);
     holder  := (25/6) - ((Data1[cell1] - OffSetY) * portion) + 1.74;
     if Data1[cell1] < 999.99 then
      DoLine(Xplotpts[cell-1],holder1, Xplotpts[cell1 -1], holder,1,0);
     repeat
       inc(cell);
     until (Data1[cell] < 999.99) or (cell >= NoOfXplots);
   until cell >= NoOfXplots;

   for i := 0 to NoOfXplots -1 do          { do first line plot points }
   begin
     if Data1[i+1] < 999.99 then
     begin
       holder  := ((25/6) - ((Data1[i+1] - OffSetY) * portion) + 1.74) * 75;
       PutPoint1(round(Xplotpts[i] * 75),round(holder));
     end;
   end;


   cell := 0;            { draw second plot line ... }
   repeat                       { check for valid first data in array }
     inc(cell);
   until (Data2[cell] < 999.99) or (cell >= NoOfXplots);
   repeat
     holder1 := (25/6) - ((Data2[cell] - OffSetY) * portion) + 1.74;
     cell1 := cell;
     repeat
       inc(cell1);
     until (Data2[cell1] < 999.99) or (cell1 >= NoOfXplots);
     holder  := (25/6) - ((Data2[cell1] - OffSetY) * portion) + 1.74;
     if Data2[cell1] < 999.99 then
      DoLine(Xplotpts[cell-1],holder1, Xplotpts[cell1 -1], holder,-1,0);
     repeat
       inc(cell);
     until (Data2[cell] < 999.99) or (cell >= NoOfXplots);
   until cell >= NoOfXplots;

   for i := 0 to NoOfXplots -1 do          { do second line plot points }
   begin
     if Data2[i+1] < 999.99 then
     begin
       holder  := ((25/6) - ((Data2[i+1] - OffSetY) * portion) + 1.74) * 75;
       PutPoint2(round(Xplotpts[i] * 75),round(holder));
     end;
   end;
   if verbose then
   begin
     at(10,16);  write('Rastor image complete.');
   end;
end;



procedure DoOutText;
var h, i, j, k, cnt : integer;
         Yval, Yend : real;
              space : string[80];

begin
  if verbose then
  begin
    at(10,17);  write('Outputing the text to printer.');
  end;
  for i := 1 to 6 do writeln(lst);
  cnt := length(Title);
  space := '';
  for i := 1 to  (105 - cnt) div 2 do space := space + ' ';
  writeln(lst,space,Title);
  writeln(lst);

  cnt := length(SubTitle);
  space := '';
  for i := 1 to (105 - cnt) div 2 do space := space + ' ';
  writeln(lst,space,SubTitle);
  writeln(lst);

  cnt := 0;
  space := '';
  for i := 1 to StartX - 7 do space := space + ' ';
  Yval := 100.0;
  Yend := (Yval - (5 * Yinc));
  repeat
    inc(cnt);
    write(lst,space,Yval:3:0,' %');
    Yval := Yval - Yinc;
    if cnt <= 5 then for i := 1 to 5 do writeln(lst);
  until Yval < Yend;
  writeln(lst);
  writeln(lst);

  k := 1;
  for i := 0 to NoOfXplots - 1 do
  begin
    h := 0;
    cnt := length(Xdata[i+1]) div 2;

    for j := k to round((Xplotpts[i] - 0.05) * 10) - cnt do
    begin
      inc(h);
      write(lst,' ');
    end;
    k := k + h + length(xData[i+1]); { k = last printed chr position on line }
    write(lst,Xdata[i+1]);
  end;

  writeln(lst);
  writeln(lst);
  writeln(lst);
  cnt := length(DataLabel1) + length(DataLabel2) + length(DataLabel3) + 15;
  space := '';
  for i := 1 to  (105 - cnt) div 2 do space := space + ' ';
  writeln(lst,space,'     ',DataLabel1,'     ',DataLabel2,'     ',DataLabel3);
  writeln(lst);
  writeln(lst,'      ',FootNote);

end;


procedure Init;
var i, j : integer;
    InStr, tmpStr : string;
    Dstr : array[0..19] of string[32];

    procedure HeaderInfo;
    begin
      at(10,1);
      write('Installability Graph Generator, ver. 1.0, Nov. 1988');
      at(10,3);
      write('INGRAPH.EXE requires a minimum of one command line argument.');
      at(10,4);
      write('This argument is the file name of the structured installability');
      at(10,5);
      write('data file; example INGRAPH WK-INT.DAT [VERBOSE].');
      at(10,7);
      write('VERBOSE - is the optional second command line agrument.');
      at(10,8);
      write('This agrument provides output to the screen of messages ');
      at(10,9);
      write('indicating the progress of the graph is being processed.');
      at(10,11);
      write('INGRAPH terminated.');
      halt;
    end;

    procedure EOFerror(number : integer);
    begin
      at(10,12);
      write(#7); { beep; }
      if number = 10 then
        write('INGRAPH Fatal error, Invalid numeric data encountered.')
          else
      if number = 9 then
        write('INGRAPH Fatal error, Invalid number of plots encountered.')
         else
        write('INGRAPH Fatal error, Unexpected End of File encountered. ');
      if verbose then
      begin
         at(10,13);
         case number of
           1 : write('Check the input file structure for control line, "*------*".');
           2 : write('EOF while trying to read the title.');
           3 : write('EOF while trying to read the subtitle.');
           4 : write('EOF while trying to read the footnote.');
           5 : write('EOF while trying to read Label 1.');
           6 : write('EOF while trying to read Label 2.');
           7 : write('EOF while trying to read Label 3.');
           8 : write('EOF while trying to read number of plots.');
         end;
      end;
      at(10,14); write('INGRAPH terminated.');
      close(InFile);
      halt;
    end;

begin
  for i := 0 to 19 do
  begin
    Data1[i] := 999.99;
    Data2[i] := 999.99;
    Data3[i] := 999.99;
  end;
  fillchar(Xdata,sizeof(Xdata),$00);

  Title      := '';
  SubTitle   := '';
  FootNote   := '';
  DataLabel1 := '';
  DataLabel2 := '';
  DataLabel3 := '';
  NoOfXplots := 0;

  if paramcount = 0 then HeaderInfo;

  if paramcount > 1 then verbose := true else verbose := false;

  if verbose then
  begin
    at(10,1);
    write('Installability Graph Generator, ver. 1.0, Nov. 1988');
  end;

  assign(InFile,ParamStr(1));   { open the input file }
  {$I-} reset(InFile); {$I+}
  result := IOresult;
  if result <> 0 then
  begin
    at(10,10);
    write('INGRAPH Fatal error, trouble opening input file! ');
    at(10,12); write('INGRAPH terminated.');
    halt;
  end;

  repeat             { read though input file pre-header to control line }
    readln(InFIle,InStr);
    if EOF(InFile) then EOFerror(1);
  until ((InStr[1] = '*') and (InStr[2] = '-'));

  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(2);         { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('TITLE',tmpStr) > 0 then  TITLE :=  copy(InStr,1,pos('TITLE',tmpStr)-2)
   else
  TITLE := InStr;


  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(3);         { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('SUBTITLE',tmpStr) > 0 then  SUBTITLE :=  copy(InStr,1,pos('SUBTITLE',tmpStr)-2)
   else
  SUBTITLE := InStr;

  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(4);         { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('FOOTNOTE',tmpStr) > 0 then  FOOTNOTE :=  copy(InStr,1,pos('FOOTNOTE',tmpStr)-2)
   else
  FOOTNOTE := InStr;


  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(5);         { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('LABEL 1',tmpStr) > 0 then  DataLabel1 :=  copy(InStr,1,pos('LABEL 1',tmpStr)-2)
   else
  DataLabel1 := InStr;



  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(6);         { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('LABEL 2',tmpStr) > 0 then  DataLabel2 :=  copy(InStr,1,pos('LABEL 2',tmpStr)-2)
   else
  DataLabel2 := InStr;


  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(7);        { read input file header info }
  until length(Instr) > 0;

  tmpStr := InStr;
  for i := 1 to length(tmpStr) do tmpStr[i] := upcase(tmpStr[i]);
  if pos('LABEL 3',tmpStr) > 0 then  DataLabel3 :=  copy(InStr,1,pos('LABEL 3',tmpStr)-2)
   else
  DataLabel3 := InStr;


  repeat
    readln(InFile,InStr);
    if EOF(InFile) then EOFerror(8);        { read input file header info }
  until length(Instr) > 0;

  result := 0;
  i := 0;
  tmpStr := '';
  repeat
    inc(i);                               { strip any spaces }
    if InStr[i] <> ' ' then tmpStr := tmpStr + Upcase(InStr[i]);
  until i >= length(InStr);

  if pos('NUMBEROFPLOTPOINTS',tmpStr) > 0 then
    val(copy(TmpStr,1,pos('NUMBEROFPLOTPOINTS',tmpstr)-2),NoOfXplots,result)
     else
    val(tmpStr,NoOfXplots,result);
  if result <> 0 then EOFerror(9);

  if verbose then  { show what has been read in to this point }
  begin
    at(10,4);  write('    Input file: ',ParamStr(1));
    at(10,5);  write('   Graph title: ',TITLE);
    at(10,6);  write('Graph subtitle: ',SUBTITLE);
    at(10,7);  write('Graph footnote: ',FOOTNOTE);
    at(10,8);  write('       Label 1: ',DataLabel1);
    at(10,9);  write('       Label 2: ',DataLabel2);
    at(10,10); write('       Label 3: ',DataLabel3);
    at(10,11); write('  No. of Plots: ',NoOfXplots);
  end;

  i := 0;                                 { read data into array of string }
  fillchar(Dstr,sizeof(Dstr),$00);        { and shuffle the data to retain }
  repeat                                  { only the last NoOfXplots data  }
    if i = NoOfXplots then  for j := 2 to NoOfXplots do Dstr[j-1] := Dstr[j];
    if i < NoOfXplots then inc(i);
    repeat
      readln(InFile,Dstr[i]);
    until EOF(InFIle) or (length(Dstr[i]) > 0);
  until EOF(InFIle);

  close(InFile);
                                { convert the data from string lines to the }
  for i := 1 to NoOfXplots do   { appropriate data fields and types }
  begin
    tmpStr := '';                    { strip any spaces for the data string }
    for j := 1 to length(Dstr[i]) do
     if Dstr[i][j] <> ' ' then tmpStr := tmpStr + Dstr[i][j];
    Dstr[i] := tmpStr;

    result := 0;                     { get first data from string }
    j := pos(',',Dstr[i]);
    Xdata[i] := copy(Dstr[i],1,j-1);
    Dstr[i] := copy(Dstr[i],j+1,length(Dstr[i])-j);

    j := pos(',',Dstr[i]);                    { get 2nd data }
    if j > 1 then val(copy(Dstr[i],1,j-1),Data1[i],result);
    Dstr[i] := copy(Dstr[i],j+1,length(Dstr[i])-j);
    if result <> 0 then EOFerror(10);
    result := 0;

    j := pos(',',Dstr[i]);                      {get 3rd data }
    if j > 1 then val(copy(Dstr[i],1,j-1),Data2[i],result);
    Dstr[i] := copy(Dstr[i],j+1,length(Dstr[i])-j);
    if result <> 0 then EOFerror(10);
    result := 0;

    j := pos(',',Dstr[i]);                    { get last data }
    if j <> 1 then val(Dstr[i],Data3[i],result);
    if result <> 0 then EOFerror(10);
  end;
  if verbose then  { show what has been read in to this point }
  begin
    at(10,14);  write('All graph data loaded.');
  end;
end;




begin
  clrscr;
  Init;
  DoFrame;
  resetlaser;
  landscapemode;
  DoOutText;
  if verbose then
  begin
    at(10,18);  write('Outputing the rastor image to printer.');
  end;
  printpage;
  terminatepage;
  if verbose then
  begin
    at(10,19);  write('Graph printing completed.');
  end;
end.